package PureMessage::MessageStore::Dir::UserView;
use strict;
use warnings;
use Carp;

sub new {
    my $p = shift;
    my $class = ref($p) || $p;
    my %data = @_;
    my $addr  = delete $data{address};
    my $name  = delete $data{name};
    my $store = delete $data{store}   || croak "Store is a required field";
    unless (exists $data{state}) {
        croak "Name is a required field" unless $name;
        croak "Address is a required field" unless $addr;
    }
    my $base_package = delete $data{base_package} || 
	"PureMessage::MessageStore::Dir::UserView";
    # create the view object
    my $view_class;
    if ($name =~ /::/) {
	$view_class = $name;
    }
    else {
	$view_class = $base_package . '::' . $name;
    }
    eval "require $view_class";
    croak "Could not load view $name: $@" if $@;
    my $view;
    eval { $view = $view_class->new(@_) };
    croak "Could not construct view $name: $@" if $@;

    return $view;
}



1;

