package PureMessage::MessageStore::UserView::Row;
use strict;
use warnings;
use Carp;

sub new {
    my $p = shift;
    my $class = ref($p) || $p;
    my %parms = @_;

    
    croak "The 'fields' parameter is not an array"
	unless $parms{fields} && ref($parms{fields}) eq 'ARRAY';
    croak "The 'data' parameter is not an array"
	unless $parms{data} && ref($parms{data}) eq 'ARRAY';

    my %row;
    for (my $i = 0; $i < @{$parms{fields}}; $i++) {
	$row{$parms{fields}->[$i]} = $parms{data}->[$i];
    }
    $parms{row} = \%row;
    return bless \%parms, $class;
}

sub message_id { shift->{id} };

sub fields {
    my $self = shift;
    return @{$self->{data}} if wantarray;
    return $self->{data}[0];
}

sub as_hash {
    return %{shift->{row}};
}


sub field {
    my ($self, $field) = @_;
    return $self->{row}{$field};
}

1;

