package PureMessage::Preferences;
use strict;
use warnings;
use Carp;

sub DEFAULT_STORAGE_CLASS() { "hdb" }

# contruct a Preferecnes object using the appropriate storage
# class.
sub new {
    my $p = shift;
    my $class = ref($p) || $p;
    my %data = @_;

    my $stg_cls = delete $data{storage_class} || DEFAULT_STORAGE_CLASS;
    $stg_cls = "PureMessage::Preferences::$stg_cls"
        unless $stg_cls =~ /::/;
    
    eval "require $stg_cls";
    croak "Failed to load storage class $stg_cls: $@" if $@;

    return $stg_cls->new(%data);
}

sub language { my $self = shift; $self->lang(@_); }

1;
